import numpy, cv2

image = cv2.resize(cv2.imread('../1st/lion.jpg', 0), (720, 405))

# Add Gaussian noises to the image
noise = numpy.random.randn(image.shape[0],image.shape[1])
image = image.astype(numpy.float32) + 10*noise
image = numpy.clip(image, 0.0, 255.0)

filtered_g = cv2.GaussianBlur(image, (0,0), 2)
filtered_b = cv2.bilateralFilter(image.astype(numpy.float32), -1, 20, 5)
filtered_m = cv2.medianBlur(image.astype(numpy.uint8), 3)

cv2.imshow('Original', image.astype(numpy.uint8))
cv2.imshow('Gaussian', filtered_g.astype(numpy.uint8))
cv2.imshow('Bilateral', filtered_b.astype(numpy.uint8))
cv2.imshow('Median', filtered_m.astype(numpy.uint8))

while 1:
    if cv2.waitKey() == 0x1b:
        break

cv2.destroyAllWindows()
