import numpy, cv2

cap = cv2.VideoCapture(0)
x0, y0, size = 320, 240, 10
mode, hoffset = 0, 0

while 1:
    stat, image = cap.read()

    if mode == 0:
        cv2.rectangle(image, (x0-size,y0-size), (x0+size,y0+size), (0,0,255))
    else:
        hsv = cv2.cvtColor(image, cv2.COLOR_BGR2HSV) + numpy.array([hoffset,0,0])
        mask = cv2.inRange(hsv, (hue+hoffset-hrange,50,100), (hue+hoffset+hrange,255,255))
        image[:,:,1] = numpy.bitwise_or(image[:,:,1], mask)
   
    cv2.imshow('Camera', image.astype(numpy.uint8))
    key = cv2.waitKey(10)

    if key == 0x1b: # ESC
        mode = mode + 1
        if mode == 2:
            break
        mean_rgb = numpy.mean(numpy.mean(\
            image[y0-size:y0+size,x0-size:x0+size,:],0),0).astype(numpy.uint8)
        mean_hsv = cv2.cvtColor(mean_rgb.reshape(1,1,3), cv2.COLOR_BGR2HSV)
	hrange = 8
	hue, sat = int(mean_hsv[0,0,0]), int(mean_hsv[0,0,1])
	if hue < 45:
            hoffset = 90 - hue
        print hue, sat, hrange

cap.release()
cv2.destroyAllWindows()


