import numpy, cv2

cv2.namedWindow('Camera')

cap = cv2.VideoCapture(0)
 
while 1:
    stat, image = cap.read()

    h, w, c = image.shape
    # 1. Scaling only
    #image = cv2.resize(image, (int(image.shape[1]*1.3), int(image.shape[0]*1.3)))
    # 2. Similarity trans.: Use getRotationMatrix2D & warpAffine
    #M = cv2.getRotationMatrix2D((w/2, h/2), 45, 0.5)
    #image = cv2.warpAffine(image, M, (w, h))
    # 3. Affine trans.: Use getAffineTransform & warpAffine
    src = numpy.array([(0, 0), (w, 0), (0, h)], numpy.float32)
    dst = numpy.array([(0, 0), (w-80, 40), (20, h-50)], numpy.float32)
    M = cv2.getAffineTransform(src, dst)
    image = cv2.warpAffine(image, M, (w, h))
    
    cv2.imshow('Camera', image)
    key = cv2.waitKey(10)

    if key == 0x1b: # ESC
        break

cap.release()
cv2.destroyAllWindows()


