import numpy, cv2

image = cv2.resize(cv2.imread('../1st/lion.jpg', 0), (720, 405))

# Simulate "shot noise"
noise_x = (numpy.random.rand(10000,1)*360).astype(int)
noise_y = (numpy.random.rand(10000,1)*405).astype(int)
image[noise_y, noise_x] = numpy.random.rand(10000,1)*255

filtered_g = cv2.GaussianBlur(image, (0,0), 2)
filtered_b = cv2.bilateralFilter(image.astype(numpy.float32), -1, 20, 5)
filtered_m = cv2.medianBlur(image.astype(numpy.uint8), 3)

cv2.imshow('Original', image.astype(numpy.uint8))
cv2.imshow('Gaussian', filtered_g.astype(numpy.uint8))
cv2.imshow('Bilateral', filtered_b.astype(numpy.uint8))
cv2.imshow('Median', filtered_m.astype(numpy.uint8))

while 1:
    if cv2.waitKey() == 0x1b:
        break

cv2.destroyAllWindows()
